;http://fukuchi.org/works/qrencode/index.en.html

;Composer un numro de tlphone : tel:+votretel
;Envoyer un sms sms:votretel:votremessage
;Envoyer un mail : mailto:moi@monserveur.com
;WIFI:T:WPA/WPA2;S:idWifi;P:password;;
Enumeration Window
  #QRFOrm 
EndEnumeration

Enumeration Gadget
  #QRText
  #QRLevel
  #QRSize
  #QRImage
EndEnumeration

Enumeration 0
  #QR_ECLEVEL_L = 0 ; lowest
  #QR_ECLEVEL_M
  #QR_ECLEVEL_Q
  #QR_ECLEVEL_H     ; highest
EndEnumeration

Structure QRCode
  Version.l
  Width.l
  pSymbolData.l
EndStructure

ImportC "qrcodelib.lib"
  QRcode_encodeString8bit(Text.p-ascii, Version.l, QRecLevel.l) As "_QRcode_encodeString8bit"
  QRcode_free(*Qrcode.QRCode) As "_QRcode_free"
EndImport

;Plan du code
Declare QRFormShow()
Declare CreateQRCode ()
Declare QRPrint()
Declare QRFormResize()
Declare QRFormClose()

QRFormShow()

Procedure QRFormShow()
  CreateImage(0, 200, 200, 32, RGB(255, 255, 255))
  
  OpenWindow(#QRForm, 0, 0, 225, 400, "QR Code generator", #PB_Window_SystemMenu|#PB_Window_ScreenCentered|#PB_Window_SizeGadget )
  TextGadget(#PB_Any, 10, 4, 50, 16, "Text" )
  EditorGadget(#QRText, 10, 20, 205, 100)
  
  TextGadget(#PB_Any, 10, 130, 50, 16, "EC_Level" )
  TrackBarGadget(#QRLevel, 10, 155, 100, 20, #QR_ECLEVEL_L, #QR_ECLEVEL_H, #PB_TrackBar_Ticks)
  SetGadgetState(#QRLevel, 2)
  
  TextGadget(#PB_Any, 110, 130, 50, 16, "Size" )
  TrackBarGadget(#QRSize, 110, 155, 100, 20, 1, 10, #PB_TrackBar_Ticks)
  SetGadgetState(#QRSize, 5)
  
  ImageGadget (#QRImage, 10, 180, 430, 550, ImageID(0))
  
  ;Evenement Window
  BindEvent(#PB_Event_CloseWindow, @QRFormClose())
  BindEvent(#PB_Event_SizeWindow, @QRFormResize())
  
  ;Evenement Gadget
  BindGadgetEvent(#QRText, @CreateQRCode())  
  BindGadgetEvent(#QRLevel, @CreateQRCode())  
  BindGadgetEvent(#QRSize, @CreateQRCode())  
  
  Repeat : WaitWindowEvent(10) : ForEver  
EndProcedure

Procedure CreateQRCode ()
  Protected *Qrcode.QRCode
  Protected Content.s = GetGadgetText(#QRText)
  Protected EC_Level = GetGadgetState(#QRLevel)
  Protected Size = GetGadgetState(#QRSize)
  Protected QRImg
  
  *Qrcode = QRcode_encodeString8bit(content, 0, EC_Level)
  
  With *Qrcode
    If *Qrcode = 0 Or \Width = 0
      ProcedureReturn #Null
    Else
      *mem = \pSymbolData
      w    = \Width
    EndIf
  EndWith
  
  QRImg  = CreateImage(#PB_Any, w, w)
  
  If StartDrawing(ImageOutput(QRImg))
    Box (0, 0, ImageWidth(QRImg), ImageHeight(QRImg), #White)  
    
    For y = 0 To w - 1
      For x = 0 To w - 1
        b = PeekB(*mem) & $FF
        If b & 1
          Plot( x, y, #Black)
        EndIf
        *mem + 1
      Next
    Next
    
    StopDrawing()
    
    w * Size
    ResizeImage(QRImg, w, w, #PB_Image_Raw)
  EndIf
  
  QRcode_free(*Qrcode)
  
  SetGadgetState(#QRImage, ImageID(QRImg))
EndProcedure

Procedure QRPrint()
  
EndProcedure

Procedure QRFormResize()
  Protected Width = WindowWidth(#QRForm)
  Protected Height = WindowHeight(#QRForm)
  
  ResizeGadget(#QRText, #PB_Ignore, #PB_Ignore, Width - 20, #PB_Ignore)
EndProcedure

Procedure QRFormClose()
  End
EndProcedure
; IDE Options = PureBasic 5.40 LTS (Windows - x86)
; Folding = --
; EnableXP